{Fraktalprogramm f. VIS3-Treiber v. Heiko P. VIS3HP.COM V07}
{Vollbildfraktal FR1MHC.PAS auf Basis Hellot-Soft Datei}
{06.09.2015 Matthias H./MHC}
{.pl71}
{$c-}
program fraktale;

const  xsize =  384   ; ysize = 288    ;   {X-Wert muss durch 4 teilbar sein}
       s     = 1000   ;
       cx    =  -0.15 ; cy    =  0.73  ;
       xstart : integer = 0 ;
       ystart : integer = 0 ;
       kmax   : integer = 100 ;
       xmin   : real = -1.25 ;
       ymin   : real = -1 ;
       xmax   : real =  1.25 ;
       ymax   : real =  1 ;

CONST FN0 = 0; {Definition Funktionsnummern Treiber}
CONST FN1 = 1;
CONST FN9 = 9;
CONST FN28 = 28;
CONST FN29 = 29;

var
  Datei       :file ;
  fname       :string[8] ;
  ja_nein     :char ;
  Zaehler,bi  :integer ;
  buffer      :array [0..127] of byte ;
  buf1        :array [0..21] of real ;
  buf2        :array [0..63] of integer ;
  RW,XD,YD,RD,DPRA,DPRB,DPUF,DANZ    :INTEGER;

  i , x, xx,xx_2,yy_3, y, yy , A , C , Z ,  k   : integer ;
  dx , dy , r , qx , qy , x0 ,x1 , y0 , y1 : real ;
  qx_1, qy_1, x1_1, y1_1                   : real ;
  qx_2, qy_2, x1_2, y1_2                   : real ;
  qx_3, qy_3, x1_3, y1_3                   : real ;
  color                                    : byte ;
  eing                                     : char ;

{Vereinbarungen fuer Treiberaufruf}
procedure visin (FN0:integer); external $02D;
procedure visbl (FN1:integer); external $02D;
procedure vispf (k,x,y,FN9:integer); external $02D;
procedure visdmavb (rw,xd,yd,rd,dpra,dprb,FN28:integer); external $02D;
procedure visdmatr (dpuf,danz,FN29:integer); external $02D;

procedure Datei_schreiben ;
begin
  clrscr;
  gotoxy(1,23);
  write('Bitte warten, VIS 3 wird gelesen !');
  rewrite(Datei) ;
  blockwrite(Datei,buf1,1) ;
  blockwrite(Datei,buf2,1) ;
  zaehler := 192*288 ;                    {Spalten/2*Zeilen}
  rw:=0 ;                                 {DMA lesen}
  xd:=0 ;
  yd:=287 ;
  rd:=2 ;                                 {von oben links nach rechts unten}
  dpra:=384 ;                             {Anzahl Spalten}
  dprb:=288 ;                             {Anzahl Zeilen}
  visdmavb(rw,xd,yd,rd,dpra,dprb,FN28) ;
  DPUF:=addr(buffer);
  DANZ:=128;                              {Anzahl Bytes pro Block}
  repeat
    visdmatr(dpuf,danz,FN29) ;
    blockwrite(Datei,buffer,1) ;
    zaehler:=zaehler-128 ;
  until zaehler = 0 ;
  close(Datei) ;
end ;

procedure Datei_lesen ;
begin
  clrscr ;
  gotoxy(1,23) ;
  write('Bitte warten, Datei wird gelesen !') ;
  reset(Datei) ;
  blockread(Datei,buf1,1) ;
  blockread(Datei,buf2,1) ;
  zaehler := 192*288 ;                    {Spalten/2*Zeilen}
  rw:=1 ;                                 {DMA schreiben}
  xd:=0 ;
  yd:=287 ;
  rd:=2 ;                                 {von oben links nach rechts unten}
  dpra:=384 ;                             {Anzahl Spalten}
  dprb:=288 ;                             {Anzahl Zeilen}
  visdmavb(rw,xd,yd,rd,dpra,dprb,FN28) ;
  DPUF:=addr(buffer);
  DANZ:=128;                              {Anzahl Bytes pro Block}
  repeat
    blockread(Datei,buffer,1) ;
    visdmatr(dpuf,danz,FN29) ;
    zaehler:=zaehler-128 ;
  until zaehler = 0 ;
  close(Datei) ;
end;


procedure step1;
begin
  dx := (xmax-xmin)/(xsize-1) ;
  dy := (ymax-ymin)/(ysize-1) ;
end ;

procedure step2;
begin
  x0 := xmin + x * dx ;
  y0 := ymin + y * dy ;
  k  := 0 ; qx := 0 ; qy := 0 ;
end ;

procedure step2_1;
begin
  x0 := xmin + x * dx ;
  y0 := ymin + y * dy ;
  k  := 0 ; qx_1 := 0 ; qy_1 := 0 ;
end ;

procedure step2_2;
begin
  x0 := xmin + x * dx ;
  y0 := ymin + y * dy ;
  k  := 0 ; qx_2 := 0 ; qy_2 := 0 ;
end ;

procedure step2_3;
begin
  x0 := xmin + x * dx ;
  y0 := ymin + y * dy ;
  k  := 0 ; qx_3 := 0 ; qy_3 := 0 ;
end ;

procedure step3;
begin
  qx := sqr(x0) ; qy := sqr(y0) ;
  y1 := qy - qx -cy ;
  x1 := 2 * x0 * y0 - cx ;
  x0 := x1 ; y0 := y1 ;
  k  := k + 1
end ;

procedure step3_1;
begin
  qx_1 := sqr(x0) ; qy_1 := sqr(y0) ;
  y1_1 := qy_1 - qx_1*qx_1 -cy ;
  x1_1 := 2 * x0 * y0 - cx ;
  x0 := x1_1 ; y0 := y1_1 ;
  k  := k + 1
end ;

procedure step3_2;
begin
  qx_2 := sqr(x0) ; qy_2 := sqr(y0) ;
  y1_2 := qy_2 - qx_2 -cy ;
  x1_2 := 2 * (x0/sqr(x0)) * y0 - cx ;
  x0 := x1_2 ; y0 := y1_2 ;
  k  := k + 1
end ;

procedure step3_3;
begin
  qx_3 := sqr(x0) ; qy_3 := sqr(y0) ;
  y1_3 := qy_3*qy_3 - qx_3 -cy ;
  x1_3 := 2 * x0 * y0 - cx ;
  x0 := x1_3 ; y0 := y1_3 ;
  k  := k + 1
end ;

procedure step4 ;
begin
  if k < kmax then begin
    color := k mod 14 + 1 ;
    vispf(color,x,y,FN9)
  end
end;

procedure step4_1 ;
begin
  if k < kmax then begin
    color := k mod 14 + 1 ;
    xx:=x+192; yy:=y+144;
    vispf(color,xx,yy,FN9)
  end
end;

procedure step4_2 ;
begin
  if k < kmax then begin
    color := k mod 14 + 1 ;
    xx_2:=x+192;
    vispf(color,xx_2,y,FN9)
  end
end;

procedure step4_3 ;
begin
  if k < kmax then begin
    color := k mod 14 + 1 ;
    yy_3:=y+144;
    vispf(color,x,yy_3,FN9)
  end
end;

procedure Algorithmus ;
label exit ;
begin
  gotoxy(1,20) ;
  writeln('Die Berechnung kann mit jeder Taste abgebrochen werden !') ;
  step1 ;
  for y := ystart to ysize  do begin
    gotoxy(1,15) ;
    write('Bildzeile: ',y) ;
    for x := xstart to xsize  do begin
      step2 ;
      while (qx + qy < s ) and ( k < kmax ) do  step3 ;
      step4 ;
      if keypressed then goto exit
    end ;
    xstart := 0
  end ;
exit : end ;

procedure Hauptmenue ;
begin
  clrscr ;
    writeln('Fraktale auf der VIS 3 mit Treiber VIS3HP.COM') ;
    writeln('       (nach Mandelbrot in 16 Farben)        ') ;
    gotoxy(1,10) ;
    writeln('Berechnung eines neuen Bildes..............1') ;
    writeln ;
    writeln('Laden eines Bildes aus dem Speicher........2') ;
    writeln ;
    writeln('Anzeige der Parameter......................3') ;
    writeln ;
    writeln('Programmende...............................0') ;
    gotoxy(1,20) ;
    write('Eingabe der gewuenschten Funktion :') ;
    repeat ;
      read(kbd,eing) ;
    until eing in ['0'..'3']
end ;

procedure Parameter ;
begin
    clrscr ;
    writeln('Parameter des Bildes :') ;
    writeln;
    writeln('X min  = ',xmin:5:2);
    writeln('X max  = ',xmax:5:2);
    writeln('Y min  = ',ymin:5:2);
    writeln('Y max  = ',ymax:5:2);
    writeln('Tiefe  = ',kmax:5);
    gotoxy(1,23) ;
    writeln('(c) 1986 HELLOT-SOFT und (c) 2015 MHC');
    gotoxy(65,23) ;
end;

procedure besetzen ;
begin
  Parameter ;
  gotoxy(1,12) ;
  write('Neue Werte (j/n) ?') ;
  repeat
    read(kbd,ja_nein) ;
  until ja_nein in ['j','n','N','J'] ;
  if ja_nein in ['j','J'] then begin
        writeln ;
        write('X min =') ;
        readln(xmin) ;
        write('X max =') ;
        readln(xmax) ;
        write('Y min =') ;
        readln(ymin) ;
        write('Y max =') ;
        readln(ymax) ;
        write('Tiefe =') ;
        readln(kmax)
      end ;
  xstart := 0 ;
  ystart := 0
end;

procedure Dateiname ;
begin
  clrscr ;
  gotoxy(1,20) ;
  write('Name der Datei (ohne Ext.) :') ;
  gotoxy(30,20) ;
  readln(fname) ;
  assign(Datei,concat(Fname,'.FRA'))
end ;

procedure Bild_lesen ;
begin
  Dateiname ;
  Datei_lesen ;
  xmin := buf1[0] ;
  xmax := buf1[1] ;
  ymin := buf1[2] ;
  ymax := buf1[3] ;
  kmax := buf2[0] ;
  xstart:=buf2[1] ;
  ystart:=buf2[2]
end ;

procedure Bild ;
begin
  parameter ;
  if xstart + ystart = 0 then visbl(FN1) ;
  if (ystart <= ysize) and (xstart < xsize) then
  begin
    Algorithmus ;
    clrscr ;
    gotoxy(1,10) ;
    write('Soll das aktuelle Bild abgespeichert werden (j/n) ?') ;
    repeat
      read(kbd,ja_nein) ;
    until ja_nein in ['J','N','n','j'] ;
    if ja_nein in ['j','J'] then begin
      Dateiname ;
      buf1[0] := xmin ;
      buf1[1] := xmax ;
      buf1[2] := ymin ;
      buf1[3] := ymax ;
      buf2[0] := kmax ;
      buf2[1] := x ;
      buf2[2] := y ;
      Datei_schreiben
    end
  end
end ;

(*  Haupt-Prozedur  *)
begin
  visin(FN0) ;
  visbl(FN1) ;
  repeat
      Hauptmenue ;
      clrscr ;
      if eing = '1' then besetzen ;
      if eing = '2' then Bild_lesen ;
      if (eing='1')or(eing='2') then Bild ;
      if eing = '3' then besetzen ;
  until eing = '0'
end.